'use strict';

exports.__esModule = true;
exports.default = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getEmptyState = require('./utils/getEmptyState');

var _getEmptyState2 = _interopRequireDefault(_getEmptyState);

var _setupFirebaseRefs = require('./utils/setupFirebaseRefs');

var _setupFirebaseRefs2 = _interopRequireDefault(_setupFirebaseRefs);

var _detachListeners = require('./utils/detachListeners');

var _detachListeners2 = _interopRequireDefault(_detachListeners);

var _inArray = require('in-array');

var _inArray2 = _interopRequireDefault(_inArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GlobalFromFirebase = function (_Component) {
  _inherits(GlobalFromFirebase, _Component);

  function GlobalFromFirebase() {
    var _temp, _this, _ret;

    _classCallCheck(this, GlobalFromFirebase);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = (0, _getEmptyState2.default)(_this.props.firebaseRefs), _this.listeners = {}, _this.componentDidMount = function () {
      return (0, _setupFirebaseRefs2.default)(_this.props.firebaseRefs, _this.setStateAndGlobal, _this.addListener);
    }, _this.addListener = function (key, ref) {
      var listener = function listener(snapshot) {
        var value = snapshot.val();
        _this.setStateAndGlobal(key, value);
      };
      ref.on('value', listener);
      _this.registerListener(key, ref, listener);
    }, _this.registerListener = function (key, ref, listener) {
      _this.listeners[key] = { ref: ref, listener: listener };
    }, _this.setStateAndGlobal = function (key, value) {
      var _this$setState;

      global[key] = value;
      _this.setState((_this$setState = {}, _this$setState[key] = value, _this$setState), function () {
        var onUpdate = _this.props.onUpdate;
        if (onUpdate) {
          onUpdate(_this.state);
        }
      });
    }, _this.componentWillUnmount = function () {
      return (0, _detachListeners2.default)(Object.values(_this.listeners));
    }, _this.isLoaded = function () {
      return !(0, _inArray2.default)(Object.values(_this.state), null);
    }, _this.render = function () {
      var loaded = _this.isLoaded();
      var _this$props = _this.props,
          loadingScreen = _this$props.loadingScreen,
          children = _this$props.children;


      if (loaded) return children;

      if (typeof loadingScreen === 'function') {
        return loadingScreen(_this.state);
      }

      if (typeof loadingScreen !== 'undefined' && loadingScreen !== null) {
        return _react.Children.only(loadingScreen);
      }

      return null;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return GlobalFromFirebase;
}(_react.Component);

exports.default = GlobalFromFirebase;
GlobalFromFirebase.propTypes = process.env.NODE_ENV !== "production" ? {
  firebaseRefs: _propTypes2.default.object.isRequired,
  loadingScreen: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]),
  onUpdate: _propTypes2.default.func,
  children: _propTypes2.default.node.isRequired
} : {};
module.exports = exports['default'];