'use strict';

exports.__esModule = true;

var _getCachedId = require('./getCachedId');

var _getCachedId2 = _interopRequireDefault(_getCachedId);

var _updateCache = require('./updateCache');

var _updateCache2 = _interopRequireDefault(_updateCache);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var updateCacheOnChange = function updateCacheOnChange(key, ref, setStateAndGlobal) {
  ref.idRef.on('value', function (snapshot) {
    var id = snapshot.val();
    var cachedId = (0, _getCachedId2.default)(key);
    if (id !== cachedId) {
      return (0, _updateCache2.default)(key, ref.ref, id).then(function (value) {
        return setStateAndGlobal(key, value);
      });
    }
  });
};

exports.default = updateCacheOnChange;
module.exports = exports['default'];